<template>

  <label class="form-input"
         :class="{
           'success': !error && (value === 0 || value && String(value).length),
           'focused': isFocused,
           'error': error
         }">

    <the-mask v-if="mask"
              :mask="currentMask"
              :masked="false"

              class="form-input__field"

              :type="type"
              required
              :value="value"
              @input="onInput"
              :readonly="readonly"

              @focus.native="onFocusInput"
              @blur.native="onBlurInput"
    />

    <input v-else
           class="form-input__field"

           :type="type" required
           :value="dateValue || value"
           @input="onInput"
           :readonly="readonly"
           :name="name"

           @focus="onFocusInput"
           @blur="onBlurInput">

    <icon-small-arrow v-if="rightArrow" class="form-input__arrow"/>

    <span class="form-input__label">{{label}}</span>
  </label>

</template>

<script>
  import { TheMask } from 'vue-the-mask';
  import IconSmallArrow from './icons/IconSmallArrow';

  import { months } from '../assets/js/helpers/consts';

  export default {
    name: 'FormInput',
    components: {IconSmallArrow, TheMask},
    props: {
      type: {
        type: String,
        default: 'text'
      },

      label: {
        type: String,
        required: true
      },

      name: {
        type: String,
      },

      mask: {
        type: Boolean,
        default: false
      },

      maskType: {
        type: String,
        default: ''
      },

      value: {
        type: [String, Number, Date],
        default: ''
      },

      readonly: {
        type: Boolean,
        default: false
      },

      rightArrow: {
        type: Boolean,
        default: false
      },

      error: {
        type: Boolean,
        default: false,
      }
    },
    data: () => ({
      isFocused: false,
    }),
    computed: {
      dateValue() {
        if (!this.value) return;
        if (typeof this.value !== "object") return null;
        if (typeof this.value.getDate !== 'function') return null;

        return `${this.value.getDate()} ${months[this.value.getMonth()]}`
      },
      currentMask() {
        switch (this.maskType) {
          case 'time-mask':
            return '##:##';
          case 'phone-mask':
            return '+7 (###) ###-##-##';
          case 'sms-code-mask':
            return '####';
        }
      }
    },
    methods: {
      onInput(event) {
        if (event.target) {
          this.$emit('input', event.target.value)
        } else {
          this.$emit('input', event)
        }
      },

      onBlurInput() {
        this.$emit('blur');
        this.isFocused = false;

        if (this.maskType && this.maskType === 'phone-mask') {
          if (this.value === '+7 (') {
            this.$emit('input', '')
          }
        }
      },

      onFocusInput() {
        this.isFocused = true;

        if (this.maskType && this.maskType === 'phone-mask') {
          if (this.value === '') {
            this.$emit('input', '+7 (')
          }
        }
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .form-input {
    @include base-input;

    position: relative;

    display: flex;
    flex-flow: column;

    height: rem(70);
    padding: 0 rem(28);

    &.success {
      .form-input__field {
        position: relative;
        top: rem(30);
        height: auto;

        & ~ .form-input__label {
          top: rem(12);
          transform: none;

          font-size: rem(12);
          font-weight: 400;
          line-height: rem(16);
          color: rgba($black, .6);
        }
      }
    }

    &.error {
      .form-input__field ~ .form-input__label {
        color: rgba($red, .6);
      }

      .form-input__arrow {
        stroke: rgba($red, .6);
      }
    }

    &__field {
      @include p1;

      height: 100%;
      padding: 0;

      border: none;
      background: transparent;

      &:focus, &:valid {
        position: relative;
        top: rem(30);
        height: auto;

        & ~ .form-input__label {
          top: rem(12);
          transform: none;

          font-size: rem(12);
          font-weight: 400;
          line-height: rem(16);
          color: rgba($black, .6);
        }
      }
    }

    &__label {
      @include p1;

      position: absolute;

      top: 50%;
      transform: translateY(-50%);
      transition: all .25s;

      width: calc(100% - 3.5rem);
      overflow: hidden;
      text-overflow: ellipsis;

      color: rgba($black, .4);
      white-space: nowrap;

      pointer-events: none;
    }

    &__arrow {
      position: absolute;
      right: rem(28);
      top: 50%;
      transform: translateY(-50%);
      width: rem(10);
      height: rem(8);
    }
  }
</style>
